var config = require("../../config/config.js");
var app = getApp();
const Http = require("../../utils/HttpBasics");
const QR = require("../../utils/memberqrcode.js");
const imgurl = require("../../utils/imgurl");
Page({
  /**
   * 页面的初始数据
   */
  data: {
    myspeacialUrl: imgurl.myspeacial.url,
    teliconUrl: imgurl.telicon.url,
    wmhome: imgurl.wmhome.url,
    memberId:"000000"
  },
  phone: function (e) {
    console.log(e)
    let that = this;
    wx.makePhoneCall({
      phoneNumber: e.currentTarget.dataset.merchantlinkphone
    });
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
    console.log("渲染开始")
    Http.get({
      url: config.api.getDiscountInfo,
      data: {}
    })
    .then(res=>{
      that.setData({
        level: res.data.level ? res.data.level : ''
      })
      that.qrcode(res.data.id);

      that.setData({
        memberId: res.data.id
      })
      console.log(res.data.levelMerchantList)
      let discountMerchantList = [];
      res.data.levelMerchantList.map(file=>{
        if (file.discount != 100){
          discountMerchantList.push(file);
        }
      })
      that.setData({
        discountMerchantList: discountMerchantList,
      })
    })
  },

  goback: function () {
    wx.switchTab({
      url: '/pages/main/index',
    })
  },
  /**
   * 二维码
   */
  qrcode: function (memberId){
    let that = this;
    var size = that.setCanvasSize();
    let url = JSON.stringify({
      END: "C",
      TYPE: "memberCode",
      ID: memberId,
    });
    that.createQrCode(url, "mycanvas2", size.w, size.h);
  },
  createQrCode: function (url, canvasId, cavW, cavH) {
    //调用插件中的draw方法，绘制二维码图片
    let that = this;
    QR.api.draw(url, canvasId, cavW, cavH,function(res){
      that.setData({
        tempFilePath: res
      })
    });
  },
  //适配不同屏幕大小的canvas
  setCanvasSize: function () {
    var size = {};
    try {
      var res = wx.getSystemInfoSync();
      var scale = 750 / 400;
      //不同屏幕下canvas的适配比例；设计稿是750宽
      var width = res.windowWidth / scale;
      var height = width;
      //canvas画布为正方形
      size.w = width;
      size.h = height;
    } catch (e) {
      // Do something when catch error
      console.log("获取设备信息失败" + e);
    }
    return size;
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },
})